﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2015 Joseph Helm and Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Problems.BinPacking.Interfaces;
using HeuristicLab.Problems.BinPacking.Shapes;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Core;
using HeuristicLab.Common;


namespace HeuristicLab.Problems.BinPacking.PackingBin {
  [Item("CuboidPackingBin", "Represents a cuboidic container for a three dimensional bin-packing problem.")]
  [StorableClass]
  public class CuboidPackingBin : CuboidPackingShape, IPackingBin {

    public CuboidPackingBin(int width, int height, int depth) : base(width, height, depth) { }

    [StorableConstructor]
    protected CuboidPackingBin(bool deserializing) : base(deserializing) { }
    protected CuboidPackingBin(CuboidPackingBin original, Cloner cloner)
      : base(original, cloner) {
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new CuboidPackingBin(this, cloner);
    }
    public CuboidPackingBin()
      : base() {
    }
  }
}
